# B21_inter3.py
# * l'aspect exterieur (cle externe, codage, ...)
# - Changer la cle (y compris cle de base, rotors, ...)
#   Remarque: on met dans un meme fichier clef de base et cle interne
#

import sys
import string
import cl_b21

#====================================
#========
def save():
    global keymodified 
    nomFichier = raw_input("Nom du fichier (config par defaut) ? ")
    if nomFichier == "":
        nomFichier = "config"

    try:
        f = open( nomFichier, "w" )
    except:
        #showinfo("Error","Impossible to open file")
        print "ERROR: impossible to open file"
        return

    ch = c.rot_vow.getKey()
    f.write( ch + '\n' )
    ch = c.rot_con.getKey()    
    f.write( ch + '\n' )
    for i in range(4):
        ch = c.w[i].getExternalKey()
        f.write( ch + '\n' )
        
    for i in range(4):
        ch = c.w[i].getInternalKey()
        f.write( ch + '\n' )

    ch = c.plug_con.getAlpha()
    f.write( ch + '\n' )
    ch = c.plug_con.getAllPlugs()
    f.write( ch + '\n' )

    ch = c.plug_vow.getAlpha()
    f.write( ch + '\n' )
    ch = c.plug_vow.getAllPlugs()
    f.write( ch + '\n' )

    f.close()

    keymodified = 0
    print "====> Sauvegarde effectuee"

def restore():
    nomFichier = raw_input("Nom du fichier (config par defaut) ? ")
    if nomFichier == "":
        nomFichier = "config"
    try:
        f = open( nomFichier, "r" )
    except:
        if nomFichier == "conf_b21" :
            return
        #showinfo("Error","Impossible to open file")
        return

    try:
        c.zero()
        ch = f.readline().strip()
        c.rot_vow.setKey( ch )
        ch = f.readline().strip()
        c.rot_con.setKey( ch )
        for i in range(4):
            ch = f.readline().strip()
            c.w[i].setKey(ch)
        for i in range(4):
            ch = f.readline().strip()
            print ch
            lg = len(ch)
            for j in range(lg):
                if ch[j] != '_':
                    c.w[i].setPinsON( ch[j] )
        
        ch = f.readline().strip()
        c.plug_con.setAlpha(ch)
        ch = f.readline().strip()
        c.plug_con.setAllPlugs(ch)

        ch = f.readline().strip()
        c.plug_vow.setAlpha(ch)
        ch = f.readline().strip()
        c.plug_vow.setAllPlugs(ch)

    except:
        #showinfo("Error","Impossible to read the file")
        #menu_nouveau()
        return
    finally:
        f.close()

# ===================================
def is_maj(car):
    if string.find(string.ascii_uppercase,car) == -1: 
        return 0
    else:
        return 1

def help():
    print "md -- Passer du mode chiffrement (C) a dechif. (D) "
    print "ar -- Passer du mode Avant (A), Arriere (R) "
    print "ag:V -- avance un rotor (ici Voyel(V)/ Consonne(C)) "
    print "aw:0 -- avance une roue (ici la 1ere (0) [0,1,2,3]"
    print "av   -- avance l'ensemble des roues "
    print "re   -- Recule l'ensemble des roues "
    print "co:Y -- Code une lettre (ici 'Y') "
    print "plX:R:S -- Enfonce la fiche R dans trou S (X=(c|v))"
    print "uplX:R -- Libere une fiche (X=(c|v))"
    print "liX -- Libere toutes les fiches (X=(c|v))"
    print "po:1:A -- met un PIN ON (exemple : roue 1 (gauche), pin A)"
    print "pf:3:F -- met un PIN OFF (exemple : roue 3 (gauche), pin F)"
    print "lp   -- Liste Pins"
    print "sv   -- Sauve"
    print "res  -- Restaure"
    print "ze -- Zero"
    print "ret -- Retour a ZERO"
    print "-- HELP: help, EXIT: exit"

def shell(ch):
    global mode_cd, mode_ar, mode_pl, compteur
    print "====>", ch
    cmd = ch.split(":")

    if    cmd[0] == "co":
        if mode_ar == "R": return
        if mode_pl : return
        compteur = compteur + 1
        if mode_cd == "C":
            clair = cmd[1]
            crypto = c.cipher(clair)
            print "---> ", crypto
        else:
            crypto = cmd[1]
            clair = c.decipher(crypto)
            print "---> ", clair
    elif  cmd[0] == "md":
        if mode_cd == "C":
            mode_cd = "D"
        else:
            mode_cd = "C"
    elif  cmd[0] == "ar":
        if mode_ar == "A":
            mode_ar = "R"
        else:
            mode_ar = "A"
    elif  cmd[0] == "ag":
        if mode_ar == "A": return
        if cmd[1] == "V":
            c.rot_vow.advance()
        elif cmd[1] == "C":
            c.rot_con.advance()
    elif  cmd[0] == "aw":
        if mode_ar == "A": return
        c.w[ int(cmd[1]) ].turnClockwise()
    elif  cmd[0] == "av":
        if mode_ar == "R": return
        c.advance()
        compteur = compteur + 1
    elif  cmd[0] == "re":
        if mode_ar == "R": return
        compteur = compteur - 1
        c.goBack()
    elif  cmd[0] == "plc":
        if not c.plug_con.isSrcPlugFree(cmd[1]): return
        if not c.plug_con.isDstPlugFree(cmd[2]): return
        c.plug_con.setOnePlug(cmd[1],cmd[2])
        if c.plug_vow.isPlugged() and c.plug_con.isPlugged():
            mode_pl = False
    elif  cmd[0] == "plv":
        if not c.plug_vow.isSrcPlugFree(cmd[1]): return
        if not c.plug_vow.isDstPlugFree(cmd[2]): return
        c.plug_vow.setOnePlug(cmd[1],cmd[2])
        if c.plug_vow.isPlugged() and c.plug_con.isPlugged():
            mode_pl = False
    elif  cmd[0] == "uplv":
        mode_pl = True
        c.plug_vow.unsetOnePlug(cmd[1])
    elif  cmd[0] == "uplc":
        mode_pl = True
        c.plug_con.unsetOnePlug(cmd[1])
    elif  cmd[0] == "lic":
        mode_pl = True
        c.plug_con.unsetAllPlugs()
    elif  cmd[0] == "liv":
        mode_pl = True
        c.plug_vow.unsetAllPlugs()
    elif  cmd[0] == "lp":
        for i in range(4):
            c.w[i].info()
    elif  cmd[0] == "po":
        c.w[int(cmd[1])-1].setPinsON(cmd[2])
    elif  cmd[0] == "pf":
        c.w[int(cmd[1])-1].setPinsOFF(cmd[2])
    elif  cmd[0] == "ze":
        compteur = 0
        c.zero()
    elif  cmd[0] == "ret":
        compteur = 0
        c.rot_vow.setKey( "A" )
        c.rot_con.setKey( "A" )
        for i in range(4):
            c.w[i].setKey("A")
    elif  cmd[0] == "res":
        restore()
    elif  cmd[0] == "sv":
        save()

# ======================================================
f = open("rotors/modele")
modele = f.readline().strip()
f.close()
f = open("rotors/" + modele + ".modele")
cle_base = f.readline().strip()
cle_rotv = f.readline().strip()
cle_rotc = f.readline().strip()
f.close()
c = cl_b21.B_21(cle_base, cle_rotv, cle_rotc,0 )
mode_cd="C"
mode_ar="A"
mode_pl=False
help()
ch_old = "help"
compteur = 0

while 1:
    print "B-21, mode(C|D): ", mode_cd ,
    print " , mode(A|R): ", mode_ar , 
    print " , Compteur: ", compteur, 
    print " , Clef: ",
    print c.rot_vow.getKey(),
    print c.rot_con.getKey(),
    for i in range(4):
        print c.w[i].getExternalKey(),
    print
    print c.plug_vow.alpha,
    print c.plug_vow.getAllPlugs(), c.plug_vow.plugboard,
    print "=====", c.plug_con.alpha,
    print c.plug_con.getAllPlugs(), c.plug_con.plugboard,
    print "Pl:", mode_pl
        
    ch = raw_input("Commande ? ")
    if ch == "":
        ch = ch_old
    else:
        ch_old = ch

    print "====>", ch
    cmd = ch.split(":")

    if    cmd[0] == "help":
        help()
    elif  cmd[0] == "exit":
        break
    else:
        shell(ch)





